.\" $RCSfile: xcpt.3,v $ $Revision: #1 $ (Pixar) $Date: 2004/06/16 $
.ds ]W "Pixar \- Reyes
.TH XCPT 3 "$Date: 2004/06/16 $"
.SH NAME
.ta 1.5i
xcpt	\- generic exception-handling routine
.SH SYNOPSIS
.nf
#include <xcpt.h>

Xcpt(char *xid, int code, int severity, ...)

XcptHandler(int code, int severity, char *msg)
.fi
.SH DESCRIPTION
The subroutine
.I Xcpt\^
is called in order to ``handle'' an ``exception'', that is, an
abnormal condition detected in a program.
.I Xcpt\^
handles the exception by looking up an exception message in a message file,
formatting the message into a buffer in memory using
.IR vsprintf (3),
and calling
.I XcptHandler\^
with the formatted string (\fImsg\fR) and other information which was passed
in the call to
.IR Xcpt .
.LP
The character string pointed to by
.I xid\^
is used as a key to locate the exception message.
The first character of the string is used to construct the name of the
message file for a particular subsystem.
For example, if the first character of
.I xid\^
is \fCT\fP (the texture subsystem),
the message file might be named
.B /u1/rman/reyes/lib/messages/T.msg
in the Reyes rendering system.
.LP
The integer error code
.I code\^
and severity
.I severity\^
are simply passed along to
.I XcptHandler\^
and have no effect on
.I Xcpt\^
itself.
.LP
The message obtained from the message file may contain format items
in the style of
.IR printf (3).
In this case, additional parameters should be passed to
.I Xcpt\^
as needed to provide the values corresponding to the format items in the
message.
.LP
.I Xcpt
is defined in the (very small) object code library
.BR libxcpt.a .
.SH "SEE ALSO
.IR xcpt (5),
.IR xcptlist (1),
.IR xcptmake (1),
.IR xcptmsgs (1).
